Unit instan1;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface

function OneInstance(IDString : string): boolean;

implementation

uses
      Windows;

var
     g_hAppMutex: THandle;

function OneInstance(IDString : string): boolean;
var
     g_hAppCritSecMutex: THandle;
     dw: Longint;
begin
g_hAppCritSecMutex := CreateMutex( nil, true, PChar(IDString +
'.OneInstance32.CriticalSection') );

// if GetLastError -  

g_hAppMutex := CreateMutex( nil, false, PChar(IDString +
'.OneInstance32.Default') );

dw := WaitForSingleObject( g_hAppMutex, 0 );

Result :=  (dw <> WAIT_TIMEOUT);

ReleaseMutex( g_hAppCritSecMutex ); //    
CloseHandle( g_hAppCritSecMutex );

end;

initialization

g_hAppMutex := 0;

finalization

if LongBool( g_hAppMutex ) then
begin
ReleaseMutex( g_hAppMutex); // 
CloseHandle( g_hAppMutex );
end;

end.
