program Gorg32;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

uses
  Windows,
  Messages,
  mysetup,
  application,
  myconst,
  dbg,
  sysutils,
  instan1,
  MyString in 'MyString.pas';

{$RESOURCE ficn.res}
{$RESOURCE r.res}

var
   msg : TMsg;
   h1, h2 : THandle;
   f : longint;
   sw : boolean;
begin

if not OneInstance('GalaxyOrganizer32') then halt;

if paramcount > 0 then if UpperCase(paramstr(1)) = 'SETUP' then
     begin App.Install; ExitProcess(0); halt; end;

app.Create;

while true do begin
if not GetMessage(msg, 0, 0, 0) then begin app.terminated := true; end;

if (msg.message = WM_KEYUP) or (msg.message = WM_KEYDOWN) then begin

h1 := GetParent(msg.hwnd);
h2 := msg.hwnd; sw := false;
for f := 1 to 10 do begin

 if h1 = 0 then begin
  if SendMessage(h2, msg.message, msg.wParam, msg.lParam) = 1 then begin sw := true; break; end else break;
 end; {end if}

h2 := h1;
h1 := GetParent(h1);
end; {next f}
if sw then begin continue; end;
end; {end if}

if not app.terminated then TranslateMessage(msg);
 DispatchMessage(msg);

end; {wend}

app.Free;

end.