unit spkunit;

{
    GALAXY ORGANIZER 32 bit.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 1995-2025  Artyomov Alexander
    http://self-made-free.ru/
    aralni@mail.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

interface

procedure spk(b : word ); procedure spkon; procedure spkoff;

implementation

procedure spkon;
begin
 asm
        push    eax
        in      al, 61h
        or      al, 03h
        out     61h, al
        pop     eax
 end;
end;
procedure spkoff;
begin
 asm
        push    eax
 	in      al, 61h
        or      al, 03h
        xor     al, 03h
        out     61h, al
        pop     eax
 end;
end;
procedure spk(b : word );
var hb, lb : byte;
begin; hb := hi (b); lb := lo (b);
 asm
        push    eax
        mov     al, 0B6h
        out     43h, al
        mov     al, lb
        out     42h, al
        mov     al, hb
        out     42h, al
        pop     eax
 end;
end;

end.
